/*
 File: tabLst.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwygOverlay.xul
 Description: A Linked List of Custom "tab Elements" (a misnomer!)
 			Each tabEL contains relevant information about sets of tabs
 			relevant to each launch of wySUwyg editor in tabbed mode

*/


var WYS_TabList = {

MAXTABS: 6, //Max number of editors allowed
tabcount : 0, //no of elements in the list 


//add-easier at beginning
//paramenter- a tab , start of list
//retirns - start of list, i.e. te
  addTab : function (te, lst)
{
    
    //if(lst==null)alert("Creating new list");
   	te.nxt=lst;
   	lst=te;
   	
   	WYS_TabList.tabcount++;
	//alert("added a tab, total = "+WYS_TabList.tabcount);
   	return lst;
},

//remove a tab 

removeTab : function (te,lst)
{
 	var prev=lst; 
 	var temp=lst;
 	try{
		//alert("removing!");//rem
 		if (te==lst) //remove first  item
 		{lst=te.nxt;te=null;WYS_TabList.tabcount--; return lst;}
 		
 		while (temp!=te)
 		{
 			if (temp.nxt==null)	{return lst; }//reached end, no matching tab found 		
			//else
			prev=temp;
			temp=temp.nxt;
 		}
 		
 		prev.nxt=temp.nxt;
 		temp=null;
 		WYS_TabList.tabcount--;
 		//alert('removed tab, left '+WYS_TabList.tabcount) //rem
 		return lst;
 	
 	}catch(ex){if(wyspref_debugenabled)alert(ex.message);return lst;}
},


//find tab based on ID
//returns matching tabEl or null

findTab : function (id,lst)
{
	 var temp=lst; 
	 while (temp!=null)
	 {
	 if (temp.timestamp==id) return temp;
	 //else
	 temp=temp.nxt;
	 }
	 //alert("tab not in list");//rem
	 return null; //not found

},


//find a tab corresponding to a a browser

findTab1 : function (br,lst)
{
	 var temp=lst; 
	//if (temp!=null) alert("current: "+ temp.timestamp);//rem
	 while (temp!=null)
	 {
	
	if ( (temp.bred==br) || (temp.brsrc==br)  )
	 {return temp;}
	
	 //else
	 temp=temp.nxt;
	 }
	 
	 return null; //not found

},






//traverse, only  for debugging
traverse : function (lst)
{

 	var temp=lst; 
 	var str="on list: ";
 	while (temp!=null)
 	{
 	//document.write(temp.doc + "<br>");
 	str = str + temp.timestamp + "\n" ;
 	temp=temp.nxt;
 	}
 	
 	if(wyspref_debugenabled)alert(str);
 	
},

}// end class


//The actual element of a list
//has a tab's data and a pointer to the next el in the list
//constructor
 function tabEl (tb,dc,ts,ta,et,bre,brs)
 {
 	this.tab=tb;
 	this.doc=dc;
 	this.timestamp=ts; 
 	this.tarea=ta;
 	this.edtab=et;
 	this.bred=bre;
 	this.brsrc=brs;
 	this.nxt=null;
 }
 



	
